#include "hardware.h"
#include "Roomba.c"

int speed=0;
int dir=0;
int forward_array[21];
int array_gain[21] = {-1,-2,-3,-5,-10,-12,-14, -16,-18,-20,-20,20,18,16,14,12,10,5,3,2,1};
int forward_age[21];
int forward_weighted[21];
int a_index = 0;
int sum_force=0;
int c_drive=0;
int temp_d=0;

// Now create any global variables such as motors, servos, sensors etc
// This routine is called once only and allows you to do set up the hardware
// Dont use any 'clock' functions here - use 'delay' functions instead
void appInitHardware(void){
	 initHardware();
	 

}
// This routine is called once to allow you to set up any other variables in your
//program
// You can use 'clock' function here.
// The loopStart parameter has the current clock value in S
TICK_COUNT appInitSoftware(TICK_COUNT loopStart){


act_setConnected(&scan_servo,TRUE);

while (!SWITCH_pressed(&button))
	{
	uartGetByte(Uart2);
	}

startCreate();
uartFlushReceiveBuffer(Uart2);

return 0; // dont pause after
}
// This routine is called repeatedly - its your main loop
TICK_COUNT appControl(LOOP_COUNT loopCount, TICK_COUNT loopStart){


//Writer old = rprintfInit(marqueeGetWriter(&marquee));



distanceRead(distance);
temp_d = distance.distance.cm;



if (temp_d > 60)
	temp_d = 60;

if (temp_d == 0)
	temp_d = 70;

a_index = (speed / 12) + 10;

if (speed >= 120) dir = 1;
if (speed <= -120) dir = 0;

if (dir == 0) speed+=12;
if (dir == 1) speed-=12;
act_setSpeed(&scan_servo,speed);

//rprintf("%u\n",(temp_d / 10) );
	
forward_array[a_index] = temp_d;
forward_weighted[a_index] = (60 - temp_d) * array_gain[a_index];
//forward_age[a_index] = 0;

//for (int b_count= 0; b_count < 21; b_count++)
//	forward_age[b_count]++;

sum_force = 0;
for (int a_count= 0; a_count < 21; a_count++)  //if (forward_age[a_count] < 5)
			sum_force = sum_force + forward_weighted[a_count];

//rprintf(" \n Force Field %d ", sum_force);

 if (sum_force < 100 && sum_force > -100)
 	c_drive = RadStraight;
if (sum_force > 100)
	{
	c_drive = (2100 - sum_force) / 3;  //could be probem if this number goes negative, flips rotation. 
	if (c_drive < 1)
		c_drive = 1;
	}

if (sum_force < -100)
	{
	c_drive = (-2100 - sum_force) / 3;
	if (c_drive > -1)
		c_drive = -1;
	}

//rprintf(" \n Drive %d ", c_drive);

drive(150, c_drive);

if(a_index == 0 || a_index == 20)
		{
		for (int count= 0; count < 21; count++)
			{
			rprintfNum(10, 2, FALSE, '0', forward_array[count]);
			rprintf(" ");
			//rprintf(" %u",forward_array[count]);
			}
		rprintf(" \n");	
		
			for (int count= 0; count < 21; count++)
			{
			rprintfNum(10, 5, TRUE, '0', forward_weighted[count]);
			rprintf(" ");
			//rprintf(" %u",forward_array[count]);
			}
		rprintf(" \n");
			
		}

//rprintf("Distance=%u \n",ir_distance.distance.cm);



RoombaReadSensors();
if (sensors[SenBumpDrop] & BumpEither)
	{
	playSong(BUMP_SONG);
	roomba_distance=0;
	angle=0;
	drive(-200, RadStraight);
	while (roomba_distance > -300)
		RoombaReadSensors();
	drive(200, RadCCW);
	while (angle < 180)
		RoombaReadSensors();
	
	}	
//drive(200, RadStraight);

/*
signed char temp_c;
if (temp_c = uart1GetByte(), temp_c != -1)
{
	if (temp_c == 'q')
		speed+=5;
	if (temp_c == 'a')
		speed-=5;
	act_setSpeed(&scan_servo,speed);
}
*/
//rprintf("%d \n", act_getSpeed(&scan_servo));
/*
drive(200, RadStraight);
RoombaReadSensors();
if (sensors[SenBumpDrop] & BumpEither)
	{
	playSong(BUMP_SONG);
	roomba_distance=0;
	angle=0;
	drive(-200, RadStraight);
	while (roomba_distance > -300)
		RoombaReadSensors();
	drive(200, RadCCW);
	while (angle < 90)
		RoombaReadSensors();
	
	}
*/
//RoombaReadSensors();



return 60000; // wait for 1 second before calling me again. 1000000us = 1
//second
}
